// SolveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Solve.h"
#include "SolveDlg.h"

#include "fstream.h"

#include "matrix.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

long N=4;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSolveDlg dialog

CSolveDlg::CSolveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSolveDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSolveDlg)
	m_FileM = _T("m.dat");
	m_FileS = _T("s.dat");
	m_FileSolution = _T("solution.dat");
	m_N = 3;
	m_Nevazka = 0.0f;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSolveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSolveDlg)
	DDX_Text(pDX, IDC_EDIT1, m_FileM);
	DDV_MaxChars(pDX, m_FileM, 255);
	DDX_Text(pDX, IDC_EDIT2, m_FileS);
	DDV_MaxChars(pDX, m_FileS, 255);
	DDX_Text(pDX, IDC_EDIT3, m_FileSolution);
	DDV_MaxChars(pDX, m_FileSolution, 255);
	DDX_Text(pDX, IDC_EDIT5, m_N);
	DDV_MinMaxLong(pDX, m_N, 0, 10000);
	DDX_Text(pDX, IDC_EDIT4, m_Nevazka);
	DDV_MinMaxFloat(pDX, m_Nevazka, 0.f, 1.e+013f);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSolveDlg, CDialog)
	//{{AFX_MSG_MAP(CSolveDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnRun)
	ON_BN_CLICKED(IDC_BUTTON2, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSolveDlg message handlers

BOOL CSolveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSolveDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


void CSolveDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CSolveDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSolveDlg::OnRun() 
{
 UpdateData();
 N=m_N;
 int i,j;

 Matrix A(N,N);
 Stolb S(N);
 Stolb S2(N);
 ifstream ma(m_FileM);
 ifstream st(m_FileS);

 double m1=0;

 for(i=0;i<N;i++)
 {
   for(j=0;j<N;j++)
   {
     ma>>m1;
     A.Set(i,j,m1);
   };
   st>>m1;
   S.Set(i,m1);
 };
 ma.close();
 st.close();

 S2=Solve(A,S);

 ofstream sol(m_FileSolution);
 sol.precision(16);
 for(i=0;i<N;i++)
 {
   sol<<S2.Get(i)<<"\n";
 };
 sol.close();

 m_Nevazka=Norma(A*S2-S);

 UpdateData(FALSE);
};

void CSolveDlg::OnAbout() 
{
CAboutDlg dlg;
int i=dlg.DoModal();	
}
